models/Fosiles.php
<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "fosiles".
 *
 * @property int $id
 * @property string|null $nombre
 * @property int|null $partes
 * @property int|null $precio
 *
 * @property Desentierran[] $desentierrans
 * @property Jugadores[] $idjugadores
 */
class Fosiles extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'fosiles';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['partes', 'precio'], 'integer'],
            [['nombre'], 'string', 'max' => 50],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'nombre' => 'Nombre',
            'partes' => 'Partes',
            'precio' => 'Precio',
        ];
    }

    /**
     * Gets query for [[Desentierrans]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getDesentierrans()
    {
        return $this->hasMany(Desentierran::class, ['idfosil' => 'id']);
    }

    /**
     * Gets query for [[Idjugadores]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getIdjugadores()
    {
        return $this->hasMany(Jugadores::class, ['id' => 'idjugadores'])->viaTable('desentierran', ['idfosil' => 'id']);
    }
}

controllers/FosilesController.php
<?php

namespace app\controllers;

use app\models\Fosiles;
use yii\data\ActiveDataProvider;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * FosilesController implements the CRUD actions for Fosiles model.
 */
class FosilesController extends Controller
{
    /**
     * @inheritDoc
     */
    public function behaviors()
    {
        return array_merge(
            parent::behaviors(),
            [
                'verbs' => [
                    'class' => VerbFilter::className(),
                    'actions' => [
                        'delete' => ['POST'],
                    ],
                ],
            ]
        );
    }

    /**
     * Lists all Fosiles models.
     *
     * @return string
     */
    public function actionIndex()
    {
        $dataProvider = new ActiveDataProvider([
            'query' => Fosiles::find(),
            /*
            'pagination' => [
                'pageSize' => 50
            ],
            'sort' => [
                'defaultOrder' => [
                    'id' => SORT_DESC,
                ]
            ],
            */
        ]);

        return $this->render('index', [
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Fosiles model.
     * @param int $id ID
     * @return string
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new Fosiles model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return string|\yii\web\Response
     */
    public function actionCreate()
    {
        $model = new Fosiles();

        if ($this->request->isPost) {
            if ($model->load($this->request->post()) && $model->save()) {
                return $this->redirect(['view', 'id' => $model->id]);
            }
        } else {
            $model->loadDefaultValues();
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing Fosiles model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param int $id ID
     * @return string|\yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        if ($this->request->isPost && $model->load($this->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing Fosiles model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param int $id ID
     * @return \yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Fosiles model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param int $id ID
     * @return Fosiles the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Fosiles::findOne(['id' => $id])) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
       
    public function actionConsultaFosiles()
    {
    $dataProvider = new ActiveDataProvider([
        'query' => Fosiles::find()->select('id, nombre, partes, precio'),
        'pagination' => [
            'pageSize' => -1, // Establece el número de registros por página
        ],
    ]);

    return $this->render('consulta-fosiles', [
        'dataProvider' => $dataProvider,
    ]);
}

/* CONSULTAS PARA EL DESPLEGABLE DE LOS FOSILES */

/* Consulta para que muestren los fósiles con 1 parte en el desplegable */
    public function action1(){
     $dataProvider = new ActiveDataProvider([
        'query' => Fosiles::find()
            ->select(['id','nombre'])
            ->where(['partes' => '1']),
             ]);
        return $this->render("fosiles-con-una-parte",[
            "dataProvider"=>$dataProvider,
        ]);
    }

/* Consulta para que muestren los fósiles con 2 partes en el desplegable */
    public function action2(){
     $dataProvider = new ActiveDataProvider([
        'query' => Fosiles::find()
            ->select(['id','nombre'])
            ->where(['partes' => '2']),
             ]);
        return $this->render("fosiles-con-dos-partes",[
            "dataProvider"=>$dataProvider,
        ]);
    }
    
    
/* Consulta para que muestren los fósiles con 3 partes en el desplegable */
    public function action3(){
     $dataProvider = new ActiveDataProvider([
        'query' => Fosiles::find()
            ->select(['id','nombre'])
            ->where(['partes' => '3']),
             ]);
        return $this->render("fosiles-con-tres-partes",[
            "dataProvider"=>$dataProvider,
        ]);
    }   
    
/* Consulta para que muestren los fósiles con 4 partes en el desplegable */
    public function action4(){
     $dataProvider = new ActiveDataProvider([
        'query' => Fosiles::find()
            ->select(['id','nombre'])
            ->where(['partes' => '4']),
             ]);
        return $this->render("fosiles-con-cuarto-partes",[
            "dataProvider"=>$dataProvider,
        ]);
    }     
}

views/fosiles/_consulta-fosiles.php
<?php
use yii\helpers\ArrayHelper;
use yii\helpers\Html;

?>

<div class="card alturaminima">
    <div class="card-body tarjeta imagenAc">

        <h3 class="tituloFosiles"><?= Html::img('@web/img/fosiles/' . $model->nombre . '.png', ['alt' => 'My logo']) ?></h3>
        <h3> <?= $model->nombre ?></h3>
            <p>
                <?= Html::a('Ver datos', ['fosiles/view', 'id' => $model->id], ['class' => 'btn custom-button'])?>

            </p>
    </div>
</div>

views/fosiles/_form.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/** @var yii\web\View $this */
/** @var app\models\Fosiles $model */
/** @var yii\widgets\ActiveForm $form */
?>

<div class="fosiles-form">

    <?php $form = ActiveForm::begin(); ?>

    <?= $form->field($model, 'nombre')->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, 'partes')->textInput() ?>

    <?= $form->field($model, 'precio')->textInput() ?>

    <div class="form-group">
        <?= Html::submitButton('Save', ['class' => 'btn btn-success']) ?>
    </div>

    <?php ActiveForm::end(); ?>

</div>

views/fosiles/consulta-fosiles.php
<?php

/** @var yii\web\View $this */
use yii\helpers\Html;
use yii\widgets\ListView;
/* titulo de la parte de la página en la que estamos*/
$this->title = 'Fósiles';
?>
<? desplegable de las partes de los fósiles ?>
<div class="btn-group btn-desplegablepartes " role="group">
     <button id="btnGroupDrop1" type="button" class="btn custom-button dropdown-toggle custom-button btn-sombra" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
      Partes
     </button>
        <div class="dropdown-menu btn-sombra" aria-labelledby="btnGroupDrop1">
            <p>
              <?= Html::a('Una parte', ['fosiles/1'],   ['class'=>'btn custom-button btn-dentrodesple'])?>
              <?= Html::a('Dos partes', ['fosiles/2'], ['class'=>'btn custom-button btn-dentrodesple'])?>
              <?= Html::a('Tres partes', ['fosiles/3'], ['class'=>'btn custom-button btn-dentrodesple'])?>
              <?= Html::a('Cuarto partes', ['fosiles/4'],   ['class'=>'btn custom-button btn-dentrodesple'])?>
            </p>
        </div>
</div>

<div class="row">
    <div class=" body-content">
        <h1 class="encabezadoTitulo">Fósiles</h1>
        <h5>Quedan súper chulos en el museo pero si necesitas dinero no dudes en venderlos por una buena suma</h5>
           <?=
            ListView::widget([
                'dataProvider' => $dataProvider,
                'itemView' => '_consulta-fosiles',
                'layout' => "{items}",
                'itemOptions' => [
                    'class' => 'list-view-tarjetas',
                    'style' => 'float: left; justify-content: center; margin-top: 10px; width:32%;'
                ],
            ]);
            ?>
        
    </div>
</div>

views/fosiles/create.php
<?php

use yii\helpers\Html;

/** @var yii\web\View $this */
/** @var app\models\Fosiles $model */

$this->title = 'Create Fosiles';
$this->params['breadcrumbs'][] = ['label' => 'Fosiles', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="fosiles-create">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

views/fosiles/fosiles-con-cuarto-partes.php
<?php
use yii\widgets\ListView;
use yii\helpers\html;
?>

<? desplegable de los tipos de sombra de los peces ?>

<div class="btn-group btn-desplegablepartes2 " role="group">
     <button id="btnGroupDrop1" type="button" class="btn custom-button dropdown-toggle custom-button btn-sombra" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
      Partes
     </button>
        <div class="dropdown-menu btn-sombra" aria-labelledby="btnGroupDrop1">
            <p>
              <?= Html::a('Una parte', ['fosiles/1'],   ['class'=>'btn custom-button btn-dentrodesple'])?>
              <?= Html::a('Dos partes', ['fosiles/2'], ['class'=>'btn custom-button btn-dentrodesple'])?>
              <?= Html::a('Tres partes', ['fosiles/3'], ['class'=>'btn custom-button btn-dentrodesple'])?>
              <?= Html::a('Cuarto partes', ['fosiles/4'],   ['class'=>'btn custom-button btn-dentrodesple'])?>
            </p>
        </div>
</div>



<div ">
    <div class=" body-content">
        <h1 class="encabezadoObras">Fósiles</h1>
         <h5>Quedan súper chulos en el museo pero si necesitas dinero no dudes en venderlos por una buena suma</h5>
<?= ListView::widget([
    'dataProvider' => $dataProvider,
    'itemView' => '_consulta-fosiles', // Nombre de la vista parcial para cada ítem
    'layout' => "{items}\n{pager}", // Diseño de la lista
        'itemOptions' => [
                    'style' => 'display: inline-block; width: -10%; ',
                ],
]) ?>

    </div>
</div>  

views/fosiles/fosiles-con-dos-partes.php
<?php
use yii\widgets\ListView;
use yii\helpers\html;
?>

<? desplegable de los tipos de sombra de los peces ?>

<div class="btn-group btn-desplegablepartes2 " role="group">
     <button id="btnGroupDrop1" type="button" class="btn custom-button dropdown-toggle custom-button btn-sombra" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
      Partes
     </button>
        <div class="dropdown-menu btn-sombra" aria-labelledby="btnGroupDrop1">
            <p>
              <?= Html::a('Una parte', ['fosiles/1'],   ['class'=>'btn custom-button btn-dentrodesple'])?>
              <?= Html::a('Dos partes', ['fosiles/2'], ['class'=>'btn custom-button btn-dentrodesple'])?>
              <?= Html::a('Tres partes', ['fosiles/3'], ['class'=>'btn custom-button btn-dentrodesple'])?>
              <?= Html::a('Cuarto partes', ['fosiles/4'],   ['class'=>'btn custom-button btn-dentrodesple'])?>
            </p>
        </div>
</div>



<div class="row">
    <div class=" body-content">
        <h1 class="encabezadoObras">Fósiles</h1>
         <h5>Quedan súper chulos en el museo pero si necesitas dinero no dudes en venderlos por una buena suma</h5>
<?= ListView::widget([
    'dataProvider' => $dataProvider,
    'itemView' => '_consulta-fosiles', // Nombre de la vista parcial para cada ítem
    'layout' => "{items}\n{pager}", // Diseño de la lista
        'itemOptions' => [
                    'style' => 'float: left; justify-content: center; margin-top: 10px; width:33%; ',
                ],
]) ?>

views/fosiles/fosiles-con-tres-partes.php
<?php
use yii\widgets\ListView;
use yii\helpers\html;
?>

<? desplegable de los tipos de sombra de los peces ?>

<div class="btn-group btn-desplegablepartes2 " role="group">
     <button id="btnGroupDrop1" type="button" class="btn custom-button dropdown-toggle custom-button btn-sombra" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
      Partes
     </button>
        <div class="dropdown-menu btn-sombra" aria-labelledby="btnGroupDrop1">
            <p>
              <?= Html::a('Una parte', ['fosiles/1'],   ['class'=>'btn custom-button btn-dentrodesple'])?>
              <?= Html::a('Dos partes', ['fosiles/2'], ['class'=>'btn custom-button btn-dentrodesple'])?>
              <?= Html::a('Tres partes', ['fosiles/3'], ['class'=>'btn custom-button btn-dentrodesple'])?>
              <?= Html::a('Cuarto partes', ['fosiles/4'],   ['class'=>'btn custom-button btn-dentrodesple'])?>
            </p>
        </div>
</div>



<div class="row">
    <div class=" body-content">
        <h1 class="encabezadoObras">Fósiles</h1>
         <h5>Quedan súper chulos en el museo pero si necesitas dinero no dudes en venderlos por una buena suma</h5>
<?= ListView::widget([
    'dataProvider' => $dataProvider,
    'itemView' => '_consulta-fosiles', // Nombre de la vista parcial para cada ítem
    'layout' => "{items}\n{pager}", // Diseño de la lista
        'itemOptions' => [
                    'style' => 'float: left; justify-content: center; margin-top: 10px; width:33%; ',
                ],
]) ?>

views/fosiles/fosiles-con-una-parte.php
<?php
use yii\widgets\ListView;
use yii\helpers\html;
?>

<? desplegable de los tipos de sombra de los peces ?>

<div class="btn-group btn-desplegablepartes2 " role="group">
     <button id="btnGroupDrop1" type="button" class="btn custom-button dropdown-toggle custom-button btn-sombra" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
      Partes
     </button>
        <div class="dropdown-menu btn-sombra" aria-labelledby="btnGroupDrop1">
            <p>
              <?= Html::a('Una parte', ['fosiles/1'],   ['class'=>'btn custom-button btn-dentrodesple'])?>
              <?= Html::a('Dos partes', ['fosiles/2'], ['class'=>'btn custom-button btn-dentrodesple'])?>
              <?= Html::a('Tres partes', ['fosiles/3'], ['class'=>'btn custom-button btn-dentrodesple'])?>
              <?= Html::a('Cuarto partes', ['fosiles/4'],   ['class'=>'btn custom-button btn-dentrodesple'])?>
            </p>
        </div>
</div>



<div class="row">
    <div class=" body-content">
        <h1 class="encabezadoObras">Fósiles</h1>
         <h5>Quedan súper chulos en el museo pero si necesitas dinero no dudes en venderlos por una buena suma</h5>
<?= ListView::widget([
    'dataProvider' => $dataProvider,
    'itemView' => '_consulta-fosiles', // Nombre de la vista parcial para cada ítem
    'layout' => "{items}\n{pager}", // Diseño de la lista
        'itemOptions' => [
                    'style' => 'float: left; justify-content: center; margin-top: 10px; width:33%; ',
                ],
]) ?>

views/fosiles/index.php
<?php

use app\models\Fosiles;
use yii\helpers\Html;
use yii\helpers\Url;
use yii\grid\ActionColumn;
use yii\grid\GridView;

/** @var yii\web\View $this */
/** @var yii\data\ActiveDataProvider $dataProvider */

$this->title = 'Fósiles';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="fosiles-index">

    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        <?= Html::a('Create Fósiles', ['create'], ['class' => 'btn btn-success']) ?>
    </p>


    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'columns' => [
           

            'id',
            'nombre',
            'partes',
            'precio',
            [
                'class' => ActionColumn::className(),
                'urlCreator' => function ($action, Fosiles $model, $key, $index, $column) {
                    return Url::toRoute([$action, 'id' => $model->id]);
                 }
            ],
        ],
    ]); ?>


</div>

views/fosiles/update.php
<?php

use yii\helpers\Html;

/** @var yii\web\View $this */
/** @var app\models\Fosiles $model */

$this->title = 'Update Fosiles: ' . $model->id;
$this->params['breadcrumbs'][] = ['label' => 'Fosiles', 'url' => ['index']];
$this->params['breadcrumbs'][] = ['label' => $model->id, 'url' => ['view', 'id' => $model->id]];
$this->params['breadcrumbs'][] = 'Update';
?>
<div class="fosiles-update">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

views/fosiles/view.php
<?php

use yii\helpers\Html;
use yii\widgets\DetailView;

/** @var yii\web\View $this */
/** @var app\models\Fosiles $model */

$this->title = $model->nombre;
\yii\web\YiiAsset::register($this);
?>
<div class="fosiles-view">
    <br>
    <h1><?= Html::encode($this->title) ?></h1>
    <br>


    <?= DetailView::widget([
        'model' => $model,
        'attributes' => [
            'nombre',
            'partes',
            'precio',
        ],
    ]) ?>

</div>